import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import * as React from 'react';
import ClickOutside from '@beisen-cmps/italent-click-outside';
import { TitleTabItem, TabIcon, TabAvatarIcon, TabName, TabOtherName, TabRestTitle, TabContain, TabTriangle, TabDrop, TabDropItem, TabItemRight, Name } from './style';
import Avatar from 'ux-feature-avatar';
import Tooltip from '@beisen/tool-tip';
import { getUdcData } from './udcData';

var TabItem =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TabItem, _React$Component);

  function TabItem() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TabItem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TabItem)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      showDrop: false
    };

    _this.showDrop = function () {
      var data = _this.props.data;
      data.selected && _this.setState({
        showDrop: true
      });
    };

    _this.hideDrop = function () {
      _this.setState({
        showDrop: false
      });
    };

    _this.onSelectTab = function (tabId) {
      var data = _this.props.data;

      if (data.selected && data.dropDownItems && data.dropDownItems.length) {
        _this.showDrop();
      }

      _this.props.onSelectTab(tabId);
    };

    _this.onSelectDrop = function (dropId, tabId) {
      _this.props.onSelectDrop(dropId, tabId);

      _this.hideDrop();
    };

    return _this;
  }

  _createClass(TabItem, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          data = _this$props.data,
          index = _this$props.index;
      var showDrop = this.state.showDrop;
      var restTitle = '';

      if (data.dropDownItems) {
        var selectedItem = data.dropDownItems.filter(function (d) {
          return d.selected;
        });
        restTitle = selectedItem.length ? "".concat(selectedItem[0].title) : '';
      }

      var haveDrop = !!data.dropDownItems.length;
      var tabIcon = data.showAvatar ? React.createElement(TabAvatarIcon, null, React.createElement(Avatar, data.avatarIcon)) : React.createElement(TabIcon, {
        className: "italent-task-tab-icon ".concat(data.bgIcon),
        color: data.color
      });
      return React.createElement(TitleTabItem, {
        selected: data.selected
      }, React.createElement(TabContain, {
        "data-udc": getUdcData(index),
        onClick: function onClick() {
          _this2.onSelectTab(data.id);
        }
      }, tabIcon, React.createElement(TabItemRight, null, React.createElement(TabName, {
        selected: data.selected
      }, data.titleText ? React.createElement(Name, null, data.titleText) : React.createElement(Name, null, React.createElement(TabOtherName, null, " ", data.nameText, " "), React.createElement(TabRestTitle, null, " ", restTitle, " "))), React.createElement(TabTriangle, {
        show: haveDrop,
        bgIcon: "ittt-triangle-down"
      }))), React.createElement(ClickOutside, {
        onClickOutside: this.hideDrop
      }, React.createElement(TabDrop, {
        show: showDrop
      }, data.dropDownItems.map(function (dropItem, k) {
        return React.createElement(Tooltip, {
          title: dropItem.title
        }, React.createElement(TabDropItem, {
          selected: dropItem.selected,
          onClick: function onClick() {
            _this2.onSelectDrop(dropItem.id, data.id);
          },
          key: "IT-tab-drop-item-".concat(k)
        }, React.createElement(TabOtherName, null, " ", data.nameText, " "), React.createElement(TabRestTitle, null, " ", dropItem.title, " ")));
      }))));
    }
  }]);

  return TabItem;
}(React.Component);

export { TabItem as default };